/*
 (c) 2006,2007 Wojciech M. Zabolotny <wzab@ise.pw.edu.pl>

   This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#define  DSO_GET_INFO (0x01)
#define  DSO_VERIFY_HW (0x02)
#define  DSO_SEND_CMD (0x03)
#define  DSO_GET_STATUS (0x04)
#define  DSO_SEND_CMD_GET_STATUS (0x05)
#define  DSO_SET_PARAMS (0x06)
#define  DSO_SET_PARAM (0x07)
#define  DSO_START_ACQ (0x08)
#define  DSO_GET_DATA (0x09)

#define DSO_ACK (0x01)

// Pins' definition
#define STROBE PORTEbits.RE2
#define AUTO PORTEbits.RE1
#define INIT PORTEbits.RE0
#define SLCTIN PORTBbits.RB4
#define DTAIN PORTD
#define DTAOUT PORTD

#define data_to_scope { TRISD = 0;}
#define data_from_scope { TRISD = 0xff;}
// DSO configuration structure
typedef struct {
  uchar ack_chn; // offset 0
  uchar smp_rate; // offset 1
  uchar rd2_step; // offset 2
  uchar rd1_step; // offset 3
  uchar ch1_trig; // offset 4
  uchar ch2_trig; // offset 5
  uchar rd2_shift; // offset 6
  uchar trig_slope; // offset 7
  uchar ch1_v_offset; // offset 8
  uchar ch2_v_offset; // offset 9
  uchar trig_level; // offset 10
  uchar ch1_offset; // offset 11
  uchar ch1_gain; // offset 12
  uchar ch2_offset; // offset 13
  uchar ch2_gain; // offset 14
} dso_params;

#define BUFFERLEN (260)
extern dso_params dso_config;

// DSO specific functions
uchar dso_verify_connection(void);
uchar dso_read_status(void);
void dso_send_command(uchar cmd);
uchar dso_load_data(uchar chan);
uchar dso_transfer_parameters(void);
uchar dso_start_acq(uchar *);
void dso_pic_init(void);
